define("de_epages/molliepayments/ui/checkoutconfirmation", [
    "jquery",
    "de_epages/molliepayments/ui/checkoutconfirmationhelper",
    "ep/ajax",
    "ep/fn/busy",
    "$ready!"
], function ($, checkoutconfirmationhelper) {

    return function(
        BasketId
    ){
        var BasketForm = ep("form#BasketForm");
        var BuyButton = ep("div.Confirm-Order button.SubmitButton");
        var checkoutHelperObj;

        if (BuyButton.prop("disabled")) { return; }

        BuyButton.prop("disabled", true);

        $(document).ready(function() {
            // checkoutconfirmationhelper(BasketForm, BuyButton, IsMobile)
            checkoutHelperObj = checkoutconfirmationhelper(BasketForm, BuyButton, 0);
            // check if we come from a callback
            if ("SaveMultiCheckoutConfirmation" === checkoutHelperObj.getUrlParameterValue("ChangeAction")) {
                ep("body").busy("show");
                checkoutHelperObj.recoverMarkedCheckboxes();
                // use document element because at redirection, BasketForm selector does not work.
                document.forms["BasketForm"].submit();
            } else {
                checkoutHelperObj.addBuyButtonClickEvent(onBuyButtonClick);
                BuyButton.prop("disabled", false);
            }
        });

        function onBuyButtonClick() {
            ep("body").busy("show");
            if (!checkoutHelperObj.validateBasketFormRequiredCheckBoxes()) {
                ep("body").busy("hide");
                return false;
            }

            var mollieOrderCreationRequestData = {
                "ChangeAction": "OrderCreationMolliePayments",
                "ObjectID": BasketId,
            };

            if (ep('#AcceptTAC').length) {
                mollieOrderCreationRequestData["IsTacOK"] = 1;
            }

            if (ep('#AcceptCustomerInformation').length) {
                mollieOrderCreationRequestData["IsCustomerInformationOK"] = 1;
            }

            if (ep('textarea#CustomerComment').length && ep('textarea#CustomerComment').val != '') {
                mollieOrderCreationRequestData["CustomerComment"] = ep('textarea#CustomerComment').val();
            }

            checkoutHelperObj.doRequest(mollieOrderCreationRequestData, "POST", onSuccessfulMollieOrderCreationResponse, function(){
                return function(response) {
                    checkoutHelperObj.appendErrorAndSubmitBasketForm("mollieOrderCreationRequest", response)({
                        "Name": "OrderCreation",
                        "Reason": "ConnectionError",
                    });
                }
            });
        }

        function onSuccessfulMollieOrderCreationResponse(response) {
            if (response.Error || !response.href) {
                checkoutHelperObj.appendErrorAndSubmitBasketForm("onSuccessfulMollieOrderCreationResponse", response)(response.Error);
                return;
            }

            window.location.replace(response.href);
        }

    };
});
